'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.custom = undefined;

var _e = require('./e0');

var _e2 = require('./e1');

var _e3 = require('./e2');

var _e4 = require('./e3');

var _e5 = require('./e4');

var _e6 = require('./e5');

var _e7 = require('./e6');

var _e8 = require('./e7');

var _e9 = require('./e8');

var _e10 = require('./e9');

var _e11 = require('./e10');

var _eN = require('./e-n');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * generate a customized version of entrust's API
 * @function custom
 * @param {function} curry - a function which curries
 * @returns {object} raw+ an augmented version of the raw API
 * @example
 * import {custom} from 'entrust'
 * import curry from 'lodash/fp/curry'
 * const {e0} = custom(curry)
 */
var custom = exports.custom = function custom(curry) {
  var raw = {
    e0: _e.entrust0,
    e1: _e2.entrust1,
    e2: _e3.entrust2,
    e3: _e4.entrust3,
    e4: _e5.entrust4,
    e5: _e6.entrust5,
    e6: _e7.entrust6,
    e7: _e8.entrust7,
    e8: _e9.entrust8,
    e9: _e10.entrust9,
    e10: _e11.entrust10,
    eD: _eN.entrustD,
    eN: _eN.entrustN
  };
  return Object.keys(raw).map(function (k) {
    return _defineProperty({}, k, curry(raw[k]));
  }).reduce(function (x, y) {
    return Object.assign({}, x, y);
  }, {});
};