'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.e1 = exports.entrust1 = undefined;

var _katsuCurry = require('katsu-curry');

var entrust1 = exports.entrust1 = function entrust1(fn, a, x) {
  return x[fn](a);
};

/**
 * @method e1
 * @param {string} fn - a function name
 * @param {*} a - some parameter
 * @param {Object} x - an object
 * @returns {*}
 * @example
 * import {e1} from 'entrust'
 * const split = e1(`split`)
 * split(`:`, `c:o:o:l`) // [`c`,`o`,`o`,`l`]
 */
var e1 = exports.e1 = (0, _katsuCurry.curry)(entrust1);